Index: c/src/lib/libcpu/powerpc/mpc55xx/irq/irq.c
===================================================================
--- c/src/lib/libcpu/powerpc/mpc55xx/irq/irq.c	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libcpu/powerpc/mpc55xx/irq/irq.c	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -22,4 +22,5 @@
 
 #include <libcpu/raw_exception.h>
+#include <libcpu/powerpc-utility.h>
 
 #include <bsp/irq.h>
@@ -32,13 +33,13 @@
 
 /**
- * @brief Returns the priority @a p of IRQ @a i from the INTC.
+ * @brief Returns the priority @a priority of IRQ @a vector from the INTC.
  */
-rtems_status_code mpc55xx_intc_get_priority( int i, int *p)
+rtems_status_code mpc55xx_intc_get_priority( rtems_vector_number vector, unsigned *priority)
 {
-	if (MPC55XX_IRQ_IS_VALID( i)) {
-		*p = INTC.PSR [i].B.PRI;
+	if (MPC55XX_IRQ_IS_VALID( vector)) {
+		*priority = INTC.PSR [vector].B.PRI;
 		return RTEMS_SUCCESSFUL;
 	} else {
-		*p = MPC55XX_INTC_INVALID_PRIORITY;
+		*priority = MPC55XX_INTC_INVALID_PRIORITY;
 		return RTEMS_INVALID_NUMBER;
 	}	       
@@ -46,11 +47,11 @@
 
 /**
- * @brief Sets the priority of IRQ @a i to @a p at the INTC.
+ * @brief Sets the priority of IRQ @a vector to @a priority at the INTC.
  */
-rtems_status_code mpc55xx_intc_set_priority( int i, int p)
+rtems_status_code mpc55xx_intc_set_priority( rtems_vector_number vector, unsigned priority)
 {
-	if (MPC55XX_IRQ_IS_VALID( i) && MPC55XX_INTC_IS_VALID_PRIORITY( p)) {
-		INTC.PSR [i].B.PRI = p;
-		if (INTC.PSR [i].B.PRI == p) {
+	if (MPC55XX_IRQ_IS_VALID( vector) && MPC55XX_INTC_IS_VALID_PRIORITY( priority)) {
+		INTC.PSR [vector].B.PRI = priority;
+		if (INTC.PSR [vector].B.PRI == priority) {
 			return RTEMS_SUCCESSFUL;
 		} else {
@@ -63,10 +64,10 @@
 
 /**
- * @brief Raises the software IRQ with number @a i.
+ * @brief Raises the software IRQ with number @a vector.
  */
-rtems_status_code mpc55xx_intc_raise_software_irq( int i)
+rtems_status_code mpc55xx_intc_raise_software_irq( rtems_vector_number vector)
 {
-	if (MPC55XX_IRQ_IS_SOFTWARE( i)) {
-		INTC.SSCIR [i].B.SET = 1;
+	if (MPC55XX_IRQ_IS_SOFTWARE( vector)) {
+		INTC.SSCIR [vector].B.SET = 1;
 		return RTEMS_SUCCESSFUL;
 	} else {
@@ -76,10 +77,10 @@
 
 /**
- * @brief Clears the software IRQ with number @a i.
+ * @brief Clears the software IRQ with number @a vector.
  */
-rtems_status_code mpc55xx_intc_clear_software_irq( int i)
+rtems_status_code mpc55xx_intc_clear_software_irq( rtems_vector_number vector)
 {
-	if (MPC55XX_IRQ_IS_SOFTWARE( i)) {
-		INTC.SSCIR [i].B.CLR = 1;
+	if (MPC55XX_IRQ_IS_SOFTWARE( vector)) {
+		INTC.SSCIR [vector].B.CLR = 1;
 		return RTEMS_SUCCESSFUL;
 	} else {
@@ -93,16 +94,17 @@
 rtems_status_code mpc55xx_interrupt_handler_install(
 	rtems_vector_number vector,
-	int priority,
 	const char *info,
 	rtems_option options,
+	unsigned priority,
 	rtems_interrupt_handler handler,
 	void *arg
 )
 {
-	rtems_status_code sc = RTEMS_SUCCESSFUL;
+	if (MPC55XX_IRQ_IS_VALID( vector) && MPC55XX_INTC_IS_VALID_PRIORITY( priority)) {
+		rtems_status_code sc = RTEMS_SUCCESSFUL;
 
-	if (MPC55XX_IRQ_IS_VALID( vector) && MPC55XX_INTC_IS_VALID_PRIORITY( priority)) {
 		sc = rtems_interrupt_handler_install( vector, info, options, handler, arg);
 		RTEMS_CHECK_SC( sc, "Install interrupt handler");
+
 		return mpc55xx_intc_set_priority( vector, priority);
 	} else {
@@ -117,17 +119,14 @@
 {
 	/* Acknowlege interrupt request */
-	rtems_vector_number vector_number = INTC.IACKR.B.INTVEC;
+	rtems_vector_number vector = INTC.IACKR.B.INTVEC;
 
-	/* Save current interrupt level */
-	uint32_t level = _ISR_Get_level();
-
-	/* Enable all interrupts */
-	_ISR_Set_level( 0);
+	/* Save machine state and enable external exceptions */
+	uint32_t msr = ppc_external_exceptions_enable();
 
 	/* Dispatch interrupt handlers */
-	bsp_interrupt_handler_dispatch( vector_number);
+	bsp_interrupt_handler_dispatch( vector);
 
-	/* Restore interrupt level */
-	_ISR_Set_level( level);
+	/* Restore machine state */
+	ppc_external_exceptions_disable( msr);
 
 	/* End of interrupt */
Index: c/src/lib/libcpu/powerpc/preinstall.am
===================================================================
--- c/src/lib/libcpu/powerpc/preinstall.am	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libcpu/powerpc/preinstall.am	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -288,4 +288,8 @@
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/mpc55xx/edma.h
 
+$(PROJECT_INCLUDE)/mpc55xx/emios.h: mpc55xx/include/emios.h $(PROJECT_INCLUDE)/mpc55xx/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/mpc55xx/emios.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/mpc55xx/emios.h
+
 $(PROJECT_INCLUDE)/mpc55xx/mpc55xx.h: mpc55xx/include/mpc55xx.h $(PROJECT_INCLUDE)/mpc55xx/$(dirstamp)
 	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/mpc55xx/mpc55xx.h
